#include<cstdio>
#include<set>
#include<algorithm>
#include<vector>
#include<queue>

using namespace std;

#define REP(i,n) for(int i = 0; i < (n); ++i)
#define FOR(i,a,b) for(int i = (a); i < (b); ++i)
#define MP make_pair
#define ST first
#define ND second
#define PB push_back

#define MR 10010
#define MS 110

int n, m, a, b, prev[MR], skoj[MR], p[MR], r[MR], iter, most[2][MR], znak[MR];
int base[MR];
vector < int > g[MR], k0, k1;
queue < int > q;
int done[MR];

void makeset(int x)
{
  p[x] = x;
  r[x] = 0;
}
void unionset(int x, int y)
{
  if(r[x] > r[y])
    p[y] = x;
  else
  {
    p[x] = y;
    if(r[x] == r[y])
      r[y]++;
  }
}
int findset(int x)
{
  if(p[x] != x)
    p[x] = findset(p[x]);
  return p[x];
}

void przejdzSciezke(int nr, int nrstop)
{
  if(nr == nrstop)
    return;
  int pom = skoj[nr];
  while(true)
  {
    if(prev[pom] == -1)
    {
      przejdzSciezke(most[0][pom], pom);
      przejdzSciezke(most[1][pom], nrstop);
      skoj[most[0][pom]] = most[1][pom];
      skoj[most[1][pom]] = most[0][pom];
      break;
    }
    int pom1 = skoj[prev[pom]];
    skoj[pom] = prev[pom];
    skoj[prev[pom]] = pom;
    if(prev[pom] == nrstop)
      break;
    nr = prev[pom];
    pom = pom1;
  }
}//przejdzSciezke

bool search()
{
  while(!q.empty())
  {
    int akt = q.front(); q.pop();
    for(int i = 0; i < (int)g[akt].size(); i++)
      if(znak[g[akt][i]] == 0)
    {
      znak[g[akt][i]] = 1;
      prev[g[akt][i]] = akt;
      znak[skoj[g[akt][i]]] = 2;
      q.push(skoj[g[akt][i]]);
    }
    else if(znak[g[akt][i]] == 2)
    {
      int p0 = base[findset(akt)], p1 = base[findset(g[akt][i])];
      if(p0 == p1)
        continue;
      iter++;
      while(true)
      {
        if(done[p0] != iter)
        {
          done[p0] = iter;
          if(skoj[p0] != -1)
          {
            done[skoj[p0]] = 1;
            p0 = base[findset(prev[skoj[p0]])];
          }
        }
        else if(skoj[p0] != -1)
          break;
        if(done[p1] != iter)
        {
          done[p1] = iter;
          if(skoj[p1] != -1)
          {
            done[skoj[p1]] = 1;
            p1 = base[findset(prev[skoj[p1]])];
          }
        }
        else if(skoj[p1] != -1)
          break;
        if(skoj[p0] == -1 && skoj[p1] == -1)
          break;
      }
      if(skoj[p0] == -1 && skoj[p1] == -1 && p0 != p1)
      {
        przejdzSciezke(akt, p0);
        przejdzSciezke(g[akt][i], p1);
        skoj[akt] = g[akt][i];
        skoj[g[akt][i]] = akt;
        return 1;
      }
      else
      {
        int pom0 = base[findset(akt)];
        k0.clear();
        while(true)
        {
          if(pom0 == p0 || pom0 == p1)
            break;
          most[0][pom0] = akt;
          most[1][pom0] = g[akt][i];
          if(znak[skoj[pom0]] == 1)
          {
            znak[skoj[pom0]] = 2;
            q.push(skoj[pom0]);
          }
          k0.PB(pom0);
          k0.PB(skoj[pom0]);
          pom0 = base[findset(prev[skoj[pom0]])];
        }
        int pom1 = base[findset(g[akt][i])];
        k1.clear();
        while(true)
        {
          if(pom1 == pom0)
            break;
          most[0][pom1] = g[akt][i];
          most[1][pom1] = akt;
          if(znak[skoj[pom1]] == 1)
          {
            znak[skoj[pom1]] = 2;
            q.push(skoj[pom1]);
          }
          k1.PB(pom1);
          k1.PB(skoj[pom1]);
          pom1 = base[findset(prev[skoj[pom1]])];
        }
        FOR(i,1,(int)k0.size())
            unionset(findset(k0[i-1]), findset(k0[i]));
        FOR(i,1,(int)k1.size())
            unionset(findset(k1[i-1]), findset(k1[i]));
        if(k0.size() > 0)
          unionset(findset(pom0),findset(k0[0]));
        if(k1.size() > 0)
          unionset(findset(pom0),findset(k1[0]));
        base[findset(pom0)] = pom0;
      }
    }
  }
  return 0;
}//search

char t[MS][MS];
int dx[4] = {0,0,-1,1};
int dy[4] = {-1,1,0,0};

int N, E;

bool ok(int i, int x, int y)
{
  return dx[i]+x >= 0 && dx[i]+x < N && dy[i]+y >= 0 && dy[i]+y < E;
}

int kod[MS][MS];

int main()
{
  while(true)
  {    
    scanf("%d%d", &N, &E);
    if(!N)
      break;
    n = 0;
    REP(i,N)
    {
      scanf("%s", t[i]);      
      REP(j,E)
          if(t[i][j] != 'X')
            kod[i][j] = n++;
    }
    REP(i,N)REP(j,E)REP(k,4)
      if(t[i][j] != 'X' && ok(k,i,j) && t[i+dx[k]][j+dy[k]] != 'X')
      {
        g[kod[i][j]].PB(kod[i+dx[k]][j+dy[k]]);
        //g[(i+dx[k])*E+j+dy[k]].PB(i*E+j);
      }
    /*printf("%d\n", n);
    REP(i,n)
    {
      REP(j,(int)g[i].size())
          printf("%d ", g[i][j]);
      printf("\n");
    }*/
    REP(i,n)
        skoj[i] = -1;
    while(true)
    {
      while(!q.empty())
        q.pop();
      REP(i,n)
      {
        if(skoj[i] == -1)
        {
          znak[i] = 2;
          q.push(i);
        }
        else
          znak[i] = 0;
        done[i] = 0;
        makeset(i);
        base[i] = i;
        prev[i] = -1;
      }
      iter = 0;
      if(!search())
        break;
      //printf("cokolwiek\n");
    }
    REP(i,N)
    {
        REP(j,E)
        {
          if(t[i][j] == 'X')
          {
            printf("X");
            continue;
          }                    
          if(znak[kod[i][j]] == 2)
            printf("B");
          else
            printf("A");
          g[kod[i][j]].clear();
        }        
        printf("\n");
    }
    printf("\n"); //empty line    
  }
  return 0;
}